Index: trunk/platforms/tsar_generic_xbar/top.cpp
===================================================================
--- trunk/platforms/tsar_generic_xbar/top.cpp	(revision 402)
+++ trunk/platforms/tsar_generic_xbar/top.cpp	(revision 404)
@@ -118,6 +118,6 @@
 ///////////////////////////////////////////////////////////
 
-#define dspin_cmd_width      40
-#define dspin_rsp_width      33
+#define dspin_cmd_width      39
+#define dspin_rsp_width      32
 
 ///////////////////////////////////////////////////////////
@@ -772,10 +772,25 @@
             std::ostringstream m2p_signame;
             m2p_signame << "[SIG]PROC_" << x << "_" << y << "_" << l << " M2P" ;
+            std::ostringstream cmd_signame;
+            cmd_signame << "[SIG]PROC_" << x << "_" << y << "_" << l << " CMD" ;
+            std::ostringstream rsp_signame;
+            rsp_signame << "[SIG]PROC_" << x << "_" << y << "_" << l << " RSP" ;
 
             clusters[x][y]->proc[l]->print_trace();
+            clusters[x][y]->wi_proc[l]->print_trace();
             clusters[x][y]->signal_vci_ini_proc[l].print_trace(vci_signame.str());
             clusters[x][y]->signal_dspin_p2m_proc[l].print_trace(p2m_signame.str());
             clusters[x][y]->signal_dspin_m2p_proc[l].print_trace(m2p_signame.str());
+            clusters[x][y]->signal_dspin_cmd_proc_i[l].print_trace(cmd_signame.str());
+            clusters[x][y]->signal_dspin_rsp_proc_i[l].print_trace(rsp_signame.str());
+
+            clusters[x][y]->xbar_rsp_d->print_trace();
+            clusters[x][y]->xbar_cmd_d->print_trace();
+            clusters[x][y]->signal_dspin_cmd_l2g_d.print_trace("[SIG]L2G CMD");
+            clusters[x][y]->signal_dspin_cmd_g2l_d.print_trace("[SIG]G2L CMD");
+            clusters[x][y]->signal_dspin_rsp_l2g_d.print_trace("[SIG]L2G RSP");
+            clusters[x][y]->signal_dspin_rsp_g2l_d.print_trace("[SIG]G2L RSP");
         }
+
         // trace memc[debug_memc_id] 
         if ( debug_memc_id < (CLUSTER_X * CLUSTER_Y) )
@@ -792,17 +807,23 @@
             std::ostringstream sp2m;
             sp2m << "[SIG]MEMC_" << x << "_" << y << " P2M" ;
+            std::ostringstream cmd_signame;
+            cmd_signame << "[SIG]MEMC_" << x << "_" << y <<  " CMD" ;
+            std::ostringstream rsp_signame;
+            rsp_signame << "[SIG]MEMC_" << x << "_" << y <<  " RSP" ;
 
             clusters[x][y]->memc->print_trace();
-            clusters[x][y]->xram->print_trace();
+            clusters[x][y]->wt_memc->print_trace();
             clusters[x][y]->signal_vci_tgt_memc.print_trace(smemc.str());
             clusters[x][y]->signal_vci_xram.print_trace(sxram.str());
             clusters[x][y]->signal_dspin_p2m_memc.print_trace(sp2m.str());
             clusters[x][y]->signal_dspin_m2p_memc.print_trace(sm2p.str());
+            clusters[x][y]->signal_dspin_cmd_memc_t.print_trace(cmd_signame.str());
+            clusters[x][y]->signal_dspin_rsp_memc_t.print_trace(rsp_signame.str());
         }
         
         // trace replicated peripherals
-        clusters[1][1]->mdma->print_trace();
-        clusters[1][1]->signal_vci_tgt_mdma.print_trace("[SIG]MDMA_TGT_1_1");
-        clusters[1][1]->signal_vci_ini_mdma.print_trace("[SIG]MDMA_INI_1_1");
+//        clusters[1][1]->mdma->print_trace();
+//        clusters[1][1]->signal_vci_tgt_mdma.print_trace("[SIG]MDMA_TGT_1_1");
+//        clusters[1][1]->signal_vci_ini_mdma.print_trace("[SIG]MDMA_INI_1_1");
         
 
@@ -811,11 +832,13 @@
         size_t io_y   = cluster_io_id % CLUSTER_Y;
         
-//        clusters[io_x][io_y]->brom->print_trace();
-//        clusters[io_x][io_y]->signal_vci_tgt_brom.print_trace("/SIG/BROM");
-//        clusters[io_x][io_y]->signal_vci_tgt_mtty.print_trace("VCI signal TTY");
-
-        clusters[io_x][io_y]->bdev->print_trace();
-        clusters[io_x][io_y]->signal_vci_tgt_bdev.print_trace("[SIG]BDEV_TGT");
-        clusters[io_x][io_y]->signal_vci_ini_bdev.print_trace("[SIG]BDEV_INI");
+        clusters[io_x][io_y]->brom->print_trace();
+        clusters[io_x][io_y]->wt_brom->print_trace();
+        clusters[io_x][io_y]->signal_vci_tgt_brom.print_trace("[SIG]BROM");
+        clusters[io_x][io_y]->signal_dspin_cmd_brom_t.print_trace("[SIG]BROM CMD");
+        clusters[io_x][io_y]->signal_dspin_rsp_brom_t.print_trace("[SIG]BROM RSP");
+
+//        clusters[io_x][io_y]->bdev->print_trace();
+//        clusters[io_x][io_y]->signal_vci_tgt_bdev.print_trace("[SIG]BDEV_TGT");
+//        clusters[io_x][io_y]->signal_vci_ini_bdev.print_trace("[SIG]BDEV_INI");
       }
 